﻿using System.Collections.Generic;
using MbUnit.Framework;

namespace DataAccess.Tests
{
    [TestFixture]
    public class LinqCustomerRepositoryTests
    {
        private LinqCustomerRepository m_CustomerRepository = null;

        [SetUp]
        public void Setup()
        {
            m_CustomerRepository = new LinqCustomerRepository();
        }

        [TearDown]
        public void TearDown()
        {
            m_CustomerRepository = null;
        }

        [Test]
        [RollBack]
        public void GetCustomers_SingleCustomer_PopulatedList()
        {
            Customer c = TestHelper.InsertCustomer();

            List<Customer> customers = m_CustomerRepository.GetCustomers();
            Assert.AreEqual(1, customers.Count);
            Assert.AreEqual(c.CustomerID, customers[0].CustomerID);
        }

        [Test]
        [RollBack]
        public void GetCustomer_SingleCustomer_PopulatedCustomer()
        {
            Customer c = TestHelper.InsertCustomer();

            Customer customer = m_CustomerRepository.GetCustomer(c.CustomerID);
            Assert.IsNotNull(customer);
            Assert.AreEqual(c.CustomerID, customer.CustomerID);
        }
    }
}
