﻿using System.Linq;
using System.Collections.Generic;

namespace DataAccess
{
    public class LinqCustomerRepository : ICustomerRepository
    {
        #region ICustomerRepository Members

        public List<Customer> GetCustomers()
        {
            using (TestingApplicationsWithMbUnitDataContext db = CreateDataContext())
            {
                var query = from c in db.Customers
                            select c;

                return query.ToList();
            }            
        }

        public Customer GetCustomer(string customerId)
        {
            using (TestingApplicationsWithMbUnitDataContext db = CreateDataContext())
            {
                var customer = (from c in db.Customers
                            where c.CustomerID == customerId
                            select c).Single();

                return customer;
            } 
        }

        #endregion

        private TestingApplicationsWithMbUnitDataContext CreateDataContext()
        {
            return new TestingApplicationsWithMbUnitDataContext();
        }
    }
}
