﻿using System.Linq;
using System.Collections.Generic;

namespace DataAccess
{
    public class LinqOrderRepository : IOrderRepository
    {
        #region IOrderRepository Members

        public bool PlaceOrder(Order order)
        {
            using (TestingApplicationsWithMbUnitDataContext db = CreateDataContext())
            {
                db.Customers.Attach(order.Customer);
                db.Orders.InsertOnSubmit(order);
                db.SubmitChanges();
            }

            return true;
        }

        public Order GetOrder(int? orderId)
        {
            using (TestingApplicationsWithMbUnitDataContext db = CreateDataContext())
            {
                Order o = (from or in db.Orders
                           where or.OrderID == orderId
                           select or).Single();

                return o;
            }
        }

        public List<Order> GetOrdersForCustomer(Customer customer)
        {
            using (TestingApplicationsWithMbUnitDataContext db = CreateDataContext())
            {
                List<Order> orders = (from o in db.Orders
                                      where o.CustomerID == customer.CustomerID
                                      select o).ToList();

                return orders;
            }
        }

        #endregion

        private TestingApplicationsWithMbUnitDataContext CreateDataContext()
        {
            return new TestingApplicationsWithMbUnitDataContext();
        }
    }
}
