﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Sample.MSTests
{
    
    
    /// <summary>
    ///This is a test class for AccountTest and is intended
    ///to contain all AccountTest Unit Tests
    ///</summary>
    [TestClass()]
    public class AccountTestEdited
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Balance
        ///</summary>
        [TestMethod()]
        public void BalanceTest()
        {
            Account target = new Account(); // TODO: Initialize to an appropriate value
            double expected = 100; // TODO: Initialize to an appropriate value
            double actual;
            target.Balance = expected;
            actual = target.Balance;
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for AccountId
        ///</summary>
        [TestMethod()]
        public void AccountIdTest()
        {
            Account target = new Account(); // TODO: Initialize to an appropriate value
            int expected = 123; // TODO: Initialize to an appropriate value
            int actual;
            target.AccountId = expected;
            actual = target.AccountId;
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Withdraw
        ///</summary>
        [TestMethod()]
        public void WithdrawTest()
        {
            Account target = new Account(); // TODO: Initialize to an appropriate value
            target.Balance = 110;
            double amount = 105; // TODO: Initialize to an appropriate value
            target.Withdraw(amount);
            Assert.AreEqual(5, target.Balance);
        }

        /// <summary>
        ///A test for Withdraw
        ///</summary>
        [TestMethod()]
        [ExpectedException(typeof(ArgumentException))]
        public void WithdrawTestWithInvaidBalance()
        {
            Account target = new Account(); // TODO: Initialize to an appropriate value
            target.Balance = 100;
            double amount = 105; // TODO: Initialize to an appropriate value
            target.Withdraw(amount);
            Assert.Fail("Should have thrown an exception");
        }

        /// <summary>
        ///A test for Deposit
        ///</summary>
        [TestMethod()]
        public void DepositTest()
        {
            Account target = new Account(); // TODO: Initialize to an appropriate value
            double amount = 110; // TODO: Initialize to an appropriate value
            target.Deposit(amount);
            Assert.AreEqual(110, target.Balance);
        }

        ///// <summary>
        /////A test for Account Constructor
        /////</summary>
        //[TestMethod()]
        //public void AccountConstructorTest()
        //{
        //    Account target = new Account();
        //    Assert.Inconclusive("TODO: Implement code to verify target");
        //}

        [TestMethod]
        public void Fail()
        {
            Assert.Fail();
        }
    }
}
