﻿using System;
using NUnit.Framework;
//using MbUnit.Framework;

namespace Sample.Tests
{
    //USING NUNIT/MbUnit
    [TestFixture]
    public class NUnitToMbUnit_AccountTests
    {
        [Test]
        public void AccountId_ValidInt_SavesData()
        {
            Account acc = new Account();
            acc.AccountId = 123;

            Assert.AreEqual(123, acc.AccountId);
        }

        [Test]
        public void Balance_ValidDouble_SavesData()
        {
            Account acc = new Account();
            acc.Balance = 100;

            Assert.AreEqual(100, acc.Balance);
        }

        [Test]
        public void Deposit_ValidAmount_AmountIncreases()
        {
            Account acc = new Account();

            double amount = 120.25;
            acc.Deposit(amount);

            Assert.AreEqual(amount, acc.Balance);
        }

        [Test]
        [ExpectedException(typeof(ArgumentException))]
        public void Withdraw_AmountMoreThanBalance_ThrowException()
        {
            Account acc = new Account();

            double amount = 150;

            acc.Withdraw(amount);

            Assert.Fail("No Exception thrown when withdrawing amount");
        }

        [Test]
        public void Withdraw_ValidAmount_BalanceDecreases()
        {
            Account acc = new Account();
            double balance = 160;
            double amount = 150;

            acc.Balance = balance;
            acc.Withdraw(amount);

            Assert.AreEqual(10, acc.Balance);
        }
    }
}
